/* ====================================================================
 * Copyright (c) 2007,      Martin Hauner
 *                          http://subcommander.tigris.org
 *
 * Subcommander is licensed as described in the file doc/COPYING, which
 * you should have received as part of this distribution.
 * ====================================================================
 */

#ifndef _SC_PROJECTWIZARD_H
#define _SC_PROJECTWIZARD_H

// qt
#include <Qt3Support/Q3Wizard>
class QLineEdit;
class QPushButton;

/**
 * Project setup wizard.
 */
class ProjectWizard : public Q3Wizard
{
  typedef Q3Wizard super;
  Q_OBJECT;

public:
  ProjectWizard( QWidget *parent = 0 );
  ~ProjectWizard();

  void showPage( QWidget* page );

  QString getProjectName() const;
  QString getTrunkName() const;
  QString getTrunkUrl() const;
  QString getBranchesName() const;
  QString getBranchesUrl() const;
  QString getTagsName() const;
  QString getTagsUrl() const;
  QString getWcName() const;
  QString getWcPath() const;

private slots:
  /** page 1 */
  void prjNameChanged(const QString&);

  /** page 2 */
  void wcNameChanged(const QString&);
  void wcPathChanged(const QString&);
  void selectPath();

  /** page 3 */
  void trunkNameChanged(const QString&);
  void trunkFromWc();

  /* page 4 */
  void branchesNameChanged(const QString&);
  void tagsNameChanged(const QString&);
  void standardLayout();


private:
  QLineEdit*   _prjName;
  QLineEdit*   _trunkName;
  QLineEdit*   _trunkUrl;
  QPushButton* _wc;
  QLineEdit*   _branchesName;
  QLineEdit*   _branchesUrl;
  QLineEdit*   _tagsName;
  QLineEdit*   _tagsUrl;
  QPushButton* _stdLayout;
  QLineEdit*   _wcName;
  QLineEdit*   _wcPath;
};

#endif // _SC_PROJECTWIZARD_H
