/* ====================================================================
 * Copyright (c) 2006-2007, Martin Hauner
 *                          http://subcommander.tigris.org
 *
 * Subcommander is licensed as described in the file doc/COPYING, which
 * you should have received as part of this distribution.
 * ====================================================================
 */

// sc
#include "config.h"
#include "WcView.h"
#include "WcViewWhatsThis.h"
#include "WcViewFlatWidget.h"
#include "WcViewTreeWidget.h"
#include "TabWidget.h"

// qt
#include <QtGui/QLayout>
#include <QtGui/QTabBar>
#include <QtGui/QTabWidget>
#include <QtGui/QComboBox>
#include <QtGui/QLabel>
#include <QtGui/QToolButton>
#include <QtGui/QStatusBar>
#include <QtGui/QCheckBox>
#include <QtGui/QWhatsThis>


WcView::WcView( ID id, WcViewModel* model, ActionStorage* actions, QWidget* parent )
: super(parent), _id(id), _model(model)
{
  QGridLayout* gl = new QGridLayout( this, 1, 1 );
  gl->setContentsMargins(0,0,0,2);

  _tabs = new TabWidget(this);
  gl->addWidget( _tabs, 0, 0 );

  _tabs->addTab( new WcViewFlatWidget(model,actions,_tabs), "&Flat" );
  _tabs->addTab( new WcViewTreeWidget(model,actions,_tabs), "&Tree" );
  //_tabs->addTab( new QWidget(_tabs), "ChangeSets" );

  QWhatsThis::add( this, WcViewWhatsThis::get() );
}

ID WcView::getId() const
{
  return _id;
}
