/* ====================================================================
 * Copyright (c) 2007,      Martin Hauner
 *                          http://subcommander.tigris.org
 *
 * Subcommander is licensed as described in the file doc/COPYING, which
 * you should have received as part of this distribution.
 * ====================================================================
 */

// sc
#include "config.h"
#include "WcViewWhatsThis.h"
#include "StatusId.h"
#include "sublib/ColorStorage.h"



static QString getStatusCodeInfo( StatusId id )
{
  QString s;
  s += "<td align=center>" + getStatusCode(id)         +  "</td>";
  s += "<td>"              + getStatusName(id)         +  "</td>";
  s += "<td bgcolor="      + getStatusColor(id).name() + "></td>";
  return s;
}

static QString getStatusCodeInfo2( StatusId id )
{
  QString s;
  s += "<td align=center>" + getStatusCode(id) + "</td>";
  s += "<td>"              + getStatusName(id) + "</td>";
  return s;
}

static QString buildWhatsThis()
{
  QString ws = 
    "<qt>";
  ws += "<b>" + _q("working copy view columns") + "</b>";
  ws += 
     "<hr>"
     "<table cellspacing=0>"
      "<tr>";
  ws += "<td><nobr>" + _q("path/name") + "</nobr></td>";
  ws += "<td>" + _q("the path and name of an item - the header shows the working copy path and url") + "<br></td>"
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("text status") + "</nobr></td>";
  ws += "<td>" + _q("whether an item is modified") +
        "<table cellspacing=1 width=100%>";
  ws += "<tr>"+ getStatusCodeInfo(StatusNormal)     +"<td></td>"+ getStatusCodeInfo(StatusAdded) +"</tr>";
  ws += "<tr>"+ getStatusCodeInfo(StatusConflicted) +"<td></td>"+ getStatusCodeInfo(StatusDeleted) +"</tr>";
  ws += "<tr>"+ getStatusCodeInfo(StatusMerged)     +"<td></td>"+ getStatusCodeInfo(StatusIgnored) +"</tr>";
  ws += "<tr>"+ getStatusCodeInfo(StatusModified)   +"<td></td>"+ getStatusCodeInfo(StatusReplaced) +"</tr>";
  ws += "<tr>"+ getStatusCodeInfo(StatusExternal)   +"<td></td>"+ getStatusCodeInfo(StatusUnversioned) +"</tr>";
  ws += "<tr>"+ getStatusCodeInfo(StatusMissing)    +"<td></td>"+ getStatusCodeInfo(StatusObstructed) +"</tr>";
  ws += "</table>"
       "</td>"
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("property status") + "</nobr></td>";
  ws += "<td>" + _q("whether an items properties are modified") +
        "<table cellspacing=1 width=100%>";
  ws += "<tr>"+ getStatusCodeInfo(StatusNormal)     +"<td></td>"+ getStatusCodeInfo(StatusConflicted) +"</tr>";
  ws += "<tr>"+ getStatusCodeInfo(StatusModified)   +"<td colspan=4></td>"+ "</tr>";
  ws += "</table>"
       "</td>"
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("working copy lock") + "</nobr></td>";
  ws += "<td>" + _q("whether a working copy folder is locked by another subversion operation") +
        "<table cellspacing=1 width=100%>";
  ws += "<tr>"+ getStatusCodeInfo2(StatusWcLockNone) +"<td></td>"+ getStatusCodeInfo2(StatusWcLockLocked) +"</tr>";
  ws += "</table>"
       "</td>"
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("added with history") + "</nobr></td>";
  ws += "<td>" +_q("whether an item is added with history") +
        "<table cellspacing=1 width=100%>";
  ws += "<tr>"+ getStatusCodeInfo2(StatusHistoryNone) +"<td></td>"+ getStatusCodeInfo2(StatusHistory) +"</tr>";
  ws += "</table>"
       "</td>"
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("switched") + "</nobr></td>";
  ws += "<td>" + _q("whether an item is switched relativ to its parent") + "<br>" +
        "<table cellspacing=1 width=100%>";
  ws += "<tr>"+ getStatusCodeInfo2(StatusSwitchedNo) +"<td></td>"+ getStatusCodeInfo2(StatusSwitched) +"</tr>";
  ws += "</table>"
       "</td>"
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("repository lock") + "</nobr></td>";
  ws += "<td>" + _q("whether an item is locked in the repository") +
        "<table cellspacing=1 width=100%>";
  ws += "<tr>"+ getStatusCodeInfo2(StatusLockNone)   +"<td></td>"+ getStatusCodeInfo2(StatusLockLocked) +"</tr>";
  ws += "<tr>"+ getStatusCodeInfo2(StatusLockOther)  +"<td></td>"+ getStatusCodeInfo2(StatusLockStolen) +"</tr>";
  ws += "<tr>"+ getStatusCodeInfo2(StatusLockBroken) +"<td colspan=4></td>" + "</tr>";
  ws += "</table>"
       "</td>"
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("update available") + "</nobr></td>";
  ws += "<td>" + _q("whether an item has a newer revision in the repository") +
        "<table cellspacing=1 width=100%>";
  ws += "<tr>"+ getStatusCodeInfo2(StatusUpToDate) +"<td></td>"+ getStatusCodeInfo2(StatusUpToDateNo) +"</tr>";
  ws += "</table>"
       "</td>"
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("working copy revision") + "</nobr></td>";
  ws += "<td>" + _q("the working copy revision") + "<br></td>" +
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("last committed revision") + "</nobr></td>";
  ws += "<td>" + _q("an items last committed revision") + "<br></td>" +
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("last committed author") + "</nobr></td>";
  ws += "<td>" + _q("an items last committed revision author") + "<br></td>" +
      "</tr>"
      "<tr>";
  ws += "<td><nobr>" + _q("deep status") + "</nobr></td>";
  ws += "<td>" + _q("whether there are any child items modified") + "</td>" +
      "</tr>"
     "</table>"
    "</qt>";

  return ws;
}


QString WcViewWhatsThis::get()
{
  return buildWhatsThis();
}
